#region Using declarations
using System;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.ComponentModel;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    /// <summary>
    /// Enter the description of your new custom indicator here
    /// </summary>
    [Description("Enter the description of your new custom indicator here")]
    [Gui.Design.DisplayName("ZerolagStochs")]
    public class ZerolagStochs : Indicator
    {
        #region Variables
        // Wizard generated variables
        // User defined variables (add any user defined variables below)
		
		
		
		double stok1=0,stok2=0,stok3=0,stok4=0,stok5=0,mov=0,stoksmoothed=0,smoothing=15;
int shift=0, MAType=1, cnt=0,  prevbars=0,loopbegin=0;

bool first=true;
        #endregion

        /// <summary>
        /// This method is used to configure the indicator and is called once before any bar data is loaded.
        /// </summary>
        protected override void Initialize()
        {
            Add(new Plot(Color.FromKnownColor(KnownColor.Red), PlotStyle.Line, "Mov"));
            Add(new Plot(Color.FromKnownColor(KnownColor.Green), PlotStyle.Line, "Smoothed"));
            CalculateOnBarClose	= true;
            Overlay				= false;
            PriceTypeSupported	= false;
        }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {
            // Use this method for calculating your indicator values. Assign a value to each
            // plot below by replacing 'Close[0]' with your own formula.
           
			
			if ( CurrentBar < 5 )
				return;
			 // initial checkings
// check for additional bars loading or total reloading


  
 
  loopbegin = loopbegin+1; 
 // Comment( loopbegin);            // current bar is to be recounted too
  for (shift = loopbegin; shift>= 0 ;shift--)
	{

stok1 = IStochastics(3,8,3)[shift]*0.05;
stok2 = 	IStochastics(21,89,3)[shift]*0.43;
stok3 = IStochastics(13,55,3)[shift]*0.26;
stok4 = IStochastics(8,34,3)[shift]*0.16;
stok5 = IStochastics(5,21,3)[shift]*0.10;
mov   = stok1+stok2+stok3+stok4+stok5;
stoksmoothed = mov/smoothing + Smoothed[shift+1]*(smoothing-1)/smoothing;
Mov.Set(mov);
		         Smoothed.Set(stoksmoothed);

	
	loopbegin = loopbegin-1;     
	}}
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
   
        

        #region Properties
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries Mov
        {
            get { return Values[0]; }
        }

        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries Smoothed
        {
            get { return Values[1]; }
        }

        #endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private ZerolagStochs[] cacheZerolagStochs = null;

        private static ZerolagStochs checkZerolagStochs = new ZerolagStochs();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public ZerolagStochs ZerolagStochs()
        {
            return ZerolagStochs(Input);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public ZerolagStochs ZerolagStochs(Data.IDataSeries input)
        {

            if (cacheZerolagStochs != null)
                for (int idx = 0; idx < cacheZerolagStochs.Length; idx++)
                    if (cacheZerolagStochs[idx].EqualsInput(input))
                        return cacheZerolagStochs[idx];

            ZerolagStochs indicator = new ZerolagStochs();
            indicator.SetUp();
            indicator.CalculateOnBarClose = CalculateOnBarClose;
            indicator.Input = input;

            ZerolagStochs[] tmp = new ZerolagStochs[cacheZerolagStochs == null ? 1 : cacheZerolagStochs.Length + 1];
            if (cacheZerolagStochs != null)
                cacheZerolagStochs.CopyTo(tmp, 0);
            tmp[tmp.Length - 1] = indicator;
            cacheZerolagStochs = tmp;
            Indicators.Add(indicator);

            return indicator;
        }

    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ZerolagStochs ZerolagStochs()
        {
            return _indicator.ZerolagStochs(Input);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.ZerolagStochs ZerolagStochs(Data.IDataSeries input)
        {
            return _indicator.ZerolagStochs(input);
        }

    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ZerolagStochs ZerolagStochs()
        {
            return _indicator.ZerolagStochs(Input);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.ZerolagStochs ZerolagStochs(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ZerolagStochs(input);
        }

    }
}
#endregion
